                .386P
STCK_LEN        equ     100h
extrn           _pm_info:far,_pm_init:far
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_PMODE_TEXT     Segment Para Public Use16 'CODE'
_PMODE_TEXT     EndS
_TEXT           Segment Para Public Use16 'CODE'
_TEXT           EndS
;_PMODE32        Segment Para Public Use32 'CODE'
;_PMODE32        EndS
_STACK          Segment Para Stack
_STACK          EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_TEXT           Segment Para Public Use16 'CODE'
                Assume  cs:_TEXT,ds:_TEXT,ss:_STACK
                org     0
;
ErrorTable      dw      Error_1,Error_2,Error_3,Error_4,Error_5,Error_6,Error_7
                dw      Error_8
Error_1         db      "80386 or better not detected.",13,10,"$"
Error_2         db      "System is already in protected mode and no VCPI or DPMI found.",13,10,"$"
Error_3         db      "DPMI - host isn't 32-bit.",13,10,"$"
Error_4         db      "Couldn't enable A20 gate.",13,10,"$"
Error_5         db      "DPMI - Couldn't enter into 32-bit protected mode.",13,10,"$"
Error_6         db      "DPMI - Couldn't allocate needed selectors.",13,10,"$"
Error_7         db      "DPMI not present.",13,10,"$"
Error_8         db      "XMS - Too old version (v3.0+ needed).",13,10,"$"
NoLoMem         db      "Not enough low memory.",13,10,"$"
;
msg0            db      'Hello World from Protected Mode...',13,10
                db      'Press any key to continue...',13,10,36
msg1            db      'Hello World from a Real Mode Callback...',13,10
                db      'Press any key to exit...',13,10,36
                align   4
_TEXT_codebase  dd      0
_TEXT_codesel   dw      0
_TEXT_datasel   dw      0
_TEXT_pspsel    dw      0
_TEXT_zdatasel  dw      0
_TEXT_dpl       db      0
_pmode_type     db      0
;
align 4
regstruc_edi    label   dword
regstruc_di     dw      ?,?
regstruc_esi    label   dword
regstruc_si     dw      ?,?
regstruc_ebp    label   dword
regstruc_bp     dw      ?,?
                dd      ?
regstruc_ebx    label   dword
regstruc_bx     label   word
regstruc_bl     db      ?
regstruc_bh     db      ?,?,?
regstruc_edx    label   dword
regstruc_dx     label   word
regstruc_dl     db      ?
regstruc_dh     db      ?,?,?
regstruc_ecx    label   dword
regstruc_cx     label   word
regstruc_cl     db      ?
regstruc_ch     db      ?,?,?
regstruc_eax    label   dword
regstruc_ax     label   word
regstruc_al     db      ?
regstruc_ah     db      ?,?,?
regstruc_flags  dw      ?
regstruc_es     dw      ?
regstruc_ds     dw      ?
regstruc_fs     dw      ?
regstruc_gs     dw      ?
regstruc_ip     dw      ?
regstruc_cs     dw      ?
regstruc_sp     dw      ?
regstruc_ss     dw      ?

dataselector    dw      ?

;
start:                                  ; execution starts here
        push cs                         ; DS = CS
        pop ds

        call _pm_info                   ; get information
        jnc short @@startf0             ; if no error, go on

@@startf1:
	mov si,ax			; print error message for code AX
        add si,ax
        mov dx,ErrorTable[si]
        mov ah,9
        int 21h
        mov ax,4cffh
        int 21h

@@startf0:
	xor ax,ax			; check low memory and allocate low
	mov cx,ss			;  buffer needed for protected mode
        add cx,STCK_LEN
        mov dx,es:[2]
        sub dx,cx
        cmp dx,bx
        jb @@startf1
        mov es,cx

	call _pm_init			; enter protected mode
	jc @@startf1			; if error, go to error message

        mov dataselector,ds             ; now in protected mode, preserve data
                                        ;  selector

        push ds                         ; ES = DS for register strucure
        pop es

        xor cx,cx
        mov bx,21h
        mov ax,0300h
        mov edi,offset regstruc_edi
        mov dword ptr regstruc_sp,0
        mov regstruc_ds,_TEXT
        mov regstruc_dx,offset msg0
        mov regstruc_ah,09h
        int 31h

        xor ah,ah                       ; wait for keypress
        int 16h

        push ss                         ; ES = SS for register strucure
        pop es

        sub esp,32                      ; stack space for register strucure
        mov edi,esp                     ; EDI = offset of register strucure

        push cs                         ; DS:ESI = callback routine
        pop ds
        mov esi,offset callback

        mov ax,303h                     ; INT 31h function 0303h
        int 31h                         ; allocate real mode callback

        sub esp,32                      ; stack space for register strucure
        mov edi,esp                     ; EDI = offset of register strucure

        mov dword ptr [esp+2eh],0       ; SS:SP = 0 in register strucure
        mov [esp+2ah],dx                ; IP is offset of real mode callback
        mov [esp+2ch],cx                ; CS is segment of real mode callback
        mov word ptr [esp+20h],0        ; zero FLAGS in register strucure

        xor cx,cx                       ; no parameters on stack
        xor bh,bh                       ; BH must be 0
        mov ax,301h                     ; INT 31h function 0301h

        int 31h                         ; call real mode callback


        add esp,64                      ; free stack space

        mov ah,4ch                      ; exit to DOS
        int 21h

;
callback:
        cld
        lods dword ptr ds:[esi]         ; get return seg:off from real mode
        mov dword ptr es:[edi+2ah],eax  ;  stack, and update return address
        add word ptr es:[edi+2eh],4     ; adjust SP in register strucure

        push es edi                     ; preserve register strucure ES:EDI


        mov es,cs:dataselector          ; ES = main stream data selector

        mov edi,offset regstruc_edi     ; offset of register strucure
        xor cx,cx                       ; no parameters on stack
        mov bx,21h                      ; call interrupt 21h
        mov ax,300h                     ; INT 31h function 0300h

        mov es:regstruc_dx,offset msg1  ; offset of new string, other fields
                                        ;  were set previously
        int 31h                         ; do the call to real mode

        xor ah,ah                       ; wait for keypress
        int 16h

        pop edi es                      ; restore register strucure ES:EDI

        iretd                           ; done with callback
;
_TEXT           EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
_STACK          Segment Para Stack
                db      10h*STCK_LEN dup (0)
_STACK          EndS
;۲۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲
;۲۲۲۲۲۲۲۲۲۲۲۲۲
                End     Start
